using Newtonsoft.Json;
using UnityEngine;
using System.IO;
using System.Collections.Generic;

public class JsonReadBase : Base
{
    /// <summary>
    /// ͨõJSONغͽ
    /// </summary>
    /// <typeparam name="T">Ŀ</typeparam>
    /// <param name="jsonFile">JSONļTextAsset</param>
    /// <returns>лб</returns>
    public List<T> LoadJson<T>(TextAsset jsonFile)
    {
        if (jsonFile == null)
        {
            Debug.LogError("JSONļΪաȷȷ䡣");
            return null;
        }

        try
        {
            string jsonText = jsonFile.text.Trim();

            // ȷJSONʽ
            if (!jsonText.StartsWith("["))
            {
                Debug.LogError("JSONʽԤΪ顣");
                return null;
            }

            // лΪб
            List<T> dataList = JsonConvert.DeserializeObject<List<T>>(jsonText);
            //Debug.Log($"ɹJSONм {dataList.Count}  {typeof(T).Name} Ŀ");
            return dataList;
        }
        catch (JsonException ex)
        {
            Debug.LogError($"JSONл: {ex.Message}");
            return null;
        }
    }

    /// <summary>
    /// ͨõʾݷ
    /// </summary>
    /// <typeparam name="T"></typeparam>
    /// <param name="dataList">б</param>
    /// <param name="dataTypeName">ƣ־</param>
    public void DisplayData<T>(List<T> dataList)
    {
        if (dataList == null || dataList.Count == 0)
        {
            Debug.LogWarning($"ûݿʾ");
            return;
        }

        foreach (var item in dataList)
        {
            string jsonString = JsonConvert.SerializeObject(item, Formatting.Indented);
            Debug.Log($" {jsonString}");
        }
    }
}