using UnityEngine;
using DG.Tweening;
using UnityEngine.UIElements;
using System.Collections.Generic; // DoTweenռ


[System.Serializable]
public class waypoints
{
    public List<Transform> _waypoints = new List<Transform>();
}

public class SimplePathfindingDoTween : Fun
{
    public waypoints waypoints = new waypoints();// Ԥ·
    
    public float moveSpeed;  // ƶٶȵĲֵʾٶȣ

    private int currentWaypointIndex = 0;  // ǰ·
    Vector3 Vector3 = new Vector3();

    public Tween pathTween;
    public float speedFactor=1;//ٶ

    [Header("תĶ")]public GameObject obj;
    public void MoveToNextWaypoint(GameObject gameObject, float moveSpeed)
    {
        if (currentWaypointIndex < waypoints._waypoints.Count)
        {
            // ȡĿ·
            Transform targetWaypoint = waypoints._waypoints[waypoints._waypoints.Count - 1];

            // ·֮ľ
            float distance = Vector3.Distance(gameObject.transform.position, targetWaypoint.position);

            // õٶȼʱ
            float timeToReach = distance * 10 / moveSpeed;  // ٶȿƶʱ

            // ȡ·е
            Vector3[] path = new Vector3[waypoints._waypoints.Count - currentWaypointIndex];
            for (int i = 0; i < path.Length; i++)
            {
                path[i] = waypoints._waypoints[currentWaypointIndex + i].position;
                if (i!=0&&i!= path.Length-1)
                {
                    // Y᷽һı䣬һΧ
                    path[i].y += Random.Range(-0.1f, 0.1f);  // ޸ Y ֵĲΧ
                }
               
            }

            // ʹDoTweenDOPathƽƶ
          pathTween=gameObject.transform.DOPath(path, timeToReach, PathType.Linear)
                .SetEase(Ease.Linear)
                .OnUpdate(() => {
                    
                    
                    //pathTween.timeScale = speedFactor;

                    RotateTowardsTarget(); }
                
                
                
                );  // ÿθʱת

        }
        else
        {
            Debug.Log("յ㣡");
        }
    }
    public void PauseAnimation()
    {
        // ͣ
        transform.DOPause();
    }

    // DoTweenٶȣһµٶӺһָʱ
    public void ChangeSpeed(float newSpeedFactor, float restoreTime)
    {
        // ǰʱ
        float currentSpeedFactor = pathTween.timeScale;

        // ʹTweenƽصٶ
        DOTween.To(() => currentSpeedFactor, x => pathTween.timeScale = x, newSpeedFactor, restoreTime)
            .OnKill(() =>
            {
               // Debug.Log("ü+++++++++++++++++");
            // ӳٽָԭٶ
            pathTween.timeScale = 1f;  // ָԭٶ
        });
    }
    private bool isTweenPaused = false; // ־ǷѾͣ
    private float accumulatedStopTime = 0f; // ۼƵͣʱ

    public void StopPathDoTween(float stopTime) // ͣƶ
    {
        if (isTweenPaused)
        {
            // Ѿͣۼµͣʱ
            accumulatedStopTime += stopTime;
            return;
        }

        // ͣǰĶ
        pathTween.Pause();
        isTweenPaused = true;

        // һԶӳ٣ֱʱ䣩
        DOTween.To(() => 0f, x => { }, 0f, stopTime).OnKill(() =>
        {
            // ӳٽָ
            pathTween.Play();
            isTweenPaused = false;

            // ۻͣʱ䣬ͣ
            if (accumulatedStopTime > 0f)
            {
                // ʹۼƵͣʱͣ
                StopPathDoTween(accumulatedStopTime);
                accumulatedStopTime = 0f; // ۻʱ
            }
        });
    }



    void RotateTowardsTarget()
    {
        Vector3 _vector3 = Vector3 - gameObject.transform.position;
        Vector3 = gameObject.transform.position;       
        if (_vector3.x>0)
        {
            // Ŀұ߻ƽУyתΪ180㣬
            obj.transform.rotation = Quaternion.Euler(0, 0, 0);
        }
        else
        {
            // ĿߣyתΪ0㣬Ҳ
            obj.transform.rotation = Quaternion.Euler(0, 180, 0);
        }
    }
}