
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using Unity.VisualScripting.Antlr3.Runtime;
using UnityEngine;
using UnityEngine.Networking;




public class web : MonoBehaviour
{
    public const string URL = "http://192.168.3.103:8089"; // ע͵ķַ
    //public const string URL = "ws://124.221.149.22:38445/safety/cloud"; // ע͵ķַ

    // 洢صCookie
    private static Dictionary<string, string> cookieJar = new Dictionary<string, string>();

    // HTTPķ֧GETPOSTȲͬʽ
    public static async Task<string> SendRequest(string url, string method = "GET", string jsonData = "{}", Dictionary<string, string> head = null)
    {
        Debug.Log(url + "web"); // 
        // ʹUnityWebRequestHTTP֧Զ󷽷
        using (UnityWebRequest request = new UnityWebRequest(url, method))
        {
            // شڴӦ
            request.downloadHandler = new DownloadHandlerBuffer();

            // POST
            if (method == "POST" && jsonData != null)
            {
                // JSONַתΪֽ
                byte[] bodyRaw = Encoding.UTF8.GetBytes(jsonData);
                // ϴڷ
                request.uploadHandler = new UploadHandlerRaw(bodyRaw);
                // ͷָΪJSON
                request.SetRequestHeader("Content-Type", "application/json");
            }

            // ͷڣͷϢ
            if (head != null)
                foreach (string key in head.Keys)
                {
                    // ͷֵ䣬ͷ
                    request.SetRequestHeader(key, head[key]);
                }

            // Ѵ洢 Cookie
            if (cookieJar.Count > 0)
            {
                // ڴ洢cookieֵַ
                string cookieHeader = "";
                foreach (var cookie in cookieJar)
                {
                    // ʽÿcookieΪ=ֵʽӵַУԷֺŷָ
                    cookieHeader += $"{cookie.Key}={cookie.Value}; ";
                }
                // ͷеCookieֶ
                request.SetRequestHeader("Cookie", cookieHeader);
            }

            // 󲢵ȴӦ
            var operation = request.SendWebRequest();
            while (!operation.isDone)
                await Task.Yield(); // ȴɣʹawaitԷķʽ

            // ǷЭ
            if (request.result == UnityWebRequest.Result.ConnectionError || request.result == UnityWebRequest.Result.ProtocolError)
            {
                // дϢnull
                Debug.LogError($"Error: {request.error}" + url);
                // Զ嵯ʾûϢ뱻ע͵
                // Promptmgr.Instance.PromptBubble(request.error, Color.black,Color.red);
                return null;
            }
            else 
            {
                // صCookie
                string setCookieHeader;
                string str = request.downloadHandler.text; // ȡصı
                //Debug.Log(str); // ݵ̨

                // ԻȡӦͷеġSet-Cookieֶ
                if (request.GetResponseHeaders().TryGetValue("Set-Cookie", out setCookieHeader))
                {
                    // Set-CookieֶεݰֺŷָΪ
                    string[] cookies = setCookieHeader.Split(';');
                    foreach (var cookie in cookies)
                    {
                        // ÿcookieΪ=ֵʽ
                        var cookieParts = cookie.Split('=');
                        if (cookieParts.Length == 2)
                        {
                            string key = cookieParts[0].Trim(); // ȥĿո
                            string value = cookieParts[1].Trim(); // ȥֵĿո
                            // 洢cookieJarУԱʹ
                            cookieJar[key] = value;
                        }
                    }
                }

                // Ӧݣıʽ
                return request.downloadHandler.text;
            }
        }
    }
}
