using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using UnityEngine;
using Debug = UnityEngine.Debug;

public class RichText : MonoBehaviour
{
    [Header("ıԤ")] public GameObject textItem;
    private string text = "";

    public string Text
    {
        [DebuggerStepThrough] get => text;
        [DebuggerStepThrough]
        set
        {
            text = value;
            Debug.Log("===------");
            Debug.Log("<p>" + text + "</p>");
            foreach (string item in SplitStringByTags("<p>" + text + "</p>", 23))
            {
                
                GameObject gameObject = Instantiate(textItem, GameObject.Find(name).transform);
                gameObject.GetComponent<TextItem>().updateText(item);
            }

        }
    }

    public static string[] SplitStringByTags(string input, int maxLength)
    {
        // ʹʽƥ <p> ǩԼе
        var regex = new System.Text.RegularExpressions.Regex(@"<p>(.*?)</p>");
        var matches = regex.Matches(input);

        // ڴ洢
        var resultList = new System.Collections.Generic.List<string>();

        foreach (System.Text.RegularExpressions.Match match in matches)
        {
            string line = match.Groups[1].Value;  // ȡ<p></p>֮

            if (line.Length > maxLength)
            {
                // еĳȴmaxLengthֳɶַ
                for (int i = 0; i < line.Length; i += maxLength)
                {
                    int length = Math.Min(maxLength, line.Length - i);
                    resultList.Add(line.Substring(i, length));
                }
            }
            else
            {
                resultList.Add(line);
            }
        }

        return resultList.ToArray();
    }

    // Update is called once per frame
    void Update()
    {
        
    }
}
